#pragma once

#include "AdTypes.h"

namespace Ad
{
namespace Utils
{
    constexpr float kph_to_mps(const float kph);
} // namespace Ad::Utils

namespace Data
{
    Types::Vehicle          init_ego_vehicle();
    Types::NeighborVehicles init_vehicles();
} // namespace Ad::Data

namespace Visualize
{
    void print_vehicle(const Types::Vehicle &vehicle);

    void print_neighbor_vehicles(const Types::NeighborVehicles &vehicles);

    void print_scene(const Types::Vehicle &ego_vehicle, 
                     const Types::NeighborVehicles &vehicles);

} // namespace Ad::Visualize
} // namespace Ad
