#pragma once

#include <cstdint>
#include <array>

#include "AdConstants.h"

namespace Ad
{
namespace Types
{

enum class Lane
{
    Unknown,
    Left,
    Center,
    Right,
};

struct Vehicle
{
    std::int32_t id;
    Lane lane;
    double speed_mps;
    double rel_dist_m;
};

struct NeighborVehicles
{
    std::array<Vehicle, Consts::VEHICLES_PER_LANE> left_lane;
    std::array<Vehicle, Consts::VEHICLES_PER_LANE> center_lane;
    std::array<Vehicle, Consts::VEHICLES_PER_LANE> right_lane;
};

} // namespace Ad::Types
} // namespace Ad 
